local player = UnitName("player")

-- I have -no clue- why they use _3_ version numbers.
-- That's DBM for you.
local dbmVersion = "3.10"
local dbmVERSION = "3.10"
local dbmRevision = 954

local function send(msg)
	local instanceType = select(2, IsInInstance())
	if instanceType == "pvp" then
		SendAddonMessage("LVBM NSP", msg, "BATTLEGROUND")
	else
		SendAddonMessage("LVBM NSP", msg, "RAID")
	end
end

local frame = CreateFrame("Frame")
frame:SetScript("OnEvent", function(...)
	if player ~= arg4 and event == "CHAT_MSG_ADDON" and (arg1 == "LVBM" or arg1 == "LVBM NSP") then
		if arg2 == "HI!" then
			send("VER " .. tostring(dbmVersion) .. " " .. tostring(dbmVERSION) .. " " .. tostring(dbmRevision))
		else
			-- Split all the strings into a table first.
			local tbl = strsplit(" ", arg2)

			if type(tbl) == "table" then
				-- Then try to find if they sent a version number in the addon message,
				-- and if they did, check if it's more recent than what we have stored
				-- in the variables above, and if it is, update our version accordingly.
				local v, V, r = 0, 0, 0
				if tbl[2] and tonumber(tbl[2]) then
					v, V, r = tbl[2], tbl[3], tbl[4]
				elseif tbl[3] and tonumber(tbl[3]) then
					v, V, r = tbl[3], tbl[4], tbl[5]
				end
				if tonumber(v) > tonumber(dbmVersion) then dbmVersion = v end
				if tonumber(V) > tonumber(dbmVERSION) then dbmVERSION = V end
				if tonumber(r) > tonumber(dbmRevision) then dbmRevision = r end
			end

			-- Finally, respond to any version queries.
			if tbl[1] == "VER" then
				send("VER " .. tostring(dbmVersion) .. " " .. tostring(dbmVERSION) .. " " .. tostring(dbmRevision))
			end
		end
	end
end)
frame:RegisterEvent("CHAT_MSG_ADDON")

